﻿using JPK_VDEK.Core;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JPK_VDEK
{
    public static class JpkData
    {
        static private JpkExt aJpk;

        public static JPK getBaseJpk()
        {
            JPK jpk = new JPK();
            jpk.Naglowek = aJpk.Naglowek;
            jpk.Podmiot1 = aJpk.Podmiot1;
            jpk.Deklaracja = aJpk.Deklaracja;
            jpk.Ewidencja = aJpk.Ewidencja;
            if (jpk.Ewidencja != null)
            {
                jpk.Ewidencja.SprzedazWiersz = aJpk.Ewidencja.SprzedazWiersz;
                jpk.Ewidencja.SprzedazCtrl = aJpk.Ewidencja.SprzedazCtrl;
                jpk.Ewidencja.ZakupWiersz = aJpk.Ewidencja.ZakupWiersz;
                jpk.Ewidencja.ZakupCtrl = aJpk.Ewidencja.ZakupCtrl;
            }
            return jpk;
        }
        public static void setJpk(JPK ajpk)
        {
            aJpk.Naglowek = ajpk.Naglowek;
            aJpk.Podmiot1 = ajpk.Podmiot1;
            aJpk.Deklaracja = ajpk.Deklaracja;
            aJpk.Ewidencja = ajpk.Ewidencja;

        }
        public static JpkExt getJpk()
        {
            if(aJpk==null)
            {
                JpkData.initJpk();
            }
            return aJpk;
        }
        public static void initJpk()
        {
            aJpk = new JpkExt();

            aJpk.wczytalemGL = false;

            aJpk.Naglowek = new JPKNaglowek();
            aJpk.Naglowek.KodFormularza = new TNaglowekKodFormularza();
            aJpk.Naglowek.CelZlozenia = new TNaglowekCelZlozenia();
            aJpk.Naglowek.KodFormularza = new TNaglowekKodFormularza();
            aJpk.Naglowek.WariantFormularza = 21;
            aJpk.Naglowek.WariantFormularza = 1;

            aJpk.Podmiot1 = new JPKPodmiot1();

            aJpk.Deklaracja = new JPKDeklaracja();

            aJpk.Ewidencja = new JPKEwidencja();

            aJpk.Ewidencja.SprzedazWiersz = new List<JPKEwidencjaSprzedazWiersz>();

            aJpk.Ewidencja.SprzedazCtrl = new JPKEwidencjaSprzedazCtrl();

            aJpk.Ewidencja.ZakupWiersz = new List<JPKEwidencjaZakupWiersz>();

            aJpk.Ewidencja.ZakupCtrl = new JPKEwidencjaZakupCtrl();
            aJpk.ViewSP = new ObservableCollection<JPKSprzedazWierszExt>();
            aJpk.ViewZA = new ObservableCollection<JPKEwidencjaZakupWiersz>();
            

            aJpk.Sumy = new JPKSumyKontrola();

            aJpk.Cel = new TCels();
            aJpk.Urz = new US();
            aJpk.allGtu1 = 0;
            aJpk.allGtu2 = 0;
            aJpk.allGtu3 = 0;
            aJpk.allGtu4 = 0;
            aJpk.allGtu5 = 0;
            aJpk.allGtu6 = 0;
            aJpk.allGtu7 = 0;
            aJpk.allGtu8 = 0;
            aJpk.allGtu9 = 0;
            aJpk.allGtu10 = 0;
            aJpk.allGtu11 = 0;
            aJpk.allGtu12 = 0;
            aJpk.allGtu13 = 0;
            aJpk.allmpp = 0;
            aJpk.alltp = 0;
            aJpk.allmruz = 0;
            aJpk.allBrak = 0;
        }
    }
    public class JJPKZakupWierszExt: JPKEwidencjaZakupWiersz
    {
        public string TypDokumentuExt { get; set; }
        public string DokKS { get; set; }
        public JJPKZakupWierszExt()
        {
            TypDokumentuExt = "";
        }
        public void CopyFromBase(JPKEwidencjaZakupWiersz a)
        {
            LpZakupu = a.LpZakupu;
            DowodZakupu = a.DowodZakupu;
            NazwaDostawcy = a.NazwaDostawcy;
            NrDostawcy = a.NrDostawcy;
            DataWplywu = a.DataWplywu;
            DataZakupu = a.DataZakupu;
            K_40 = a.K_40;
            K_41 = a.K_41;
            K_42 = a.K_42;
            K_43 = a.K_43;
            K_44 = a.K_44;
            K_45 = a.K_45;
            K_46 = a.K_46;
            K_47 = a.K_47;
            KodKrajuNadaniaTIN = a.KodKrajuNadaniaTIN;
            DokumentZakupu = a.DokumentZakupu;
            MPP = a.MPP;
            IMP = a.IMP;
            ZakupVAT_Marza = a.ZakupVAT_Marza;
         
        }

    }
    public class JPKSprzedazWierszExt : JPKEwidencjaSprzedazWiersz
    {
        public string TypDokumentuExt { get; set; }
        public string DokKS { get; set; }
        public JPKSprzedazWierszExt()
        {
            TypDokumentuExt = "";
        }
        public void CopyFromBase(JPKEwidencjaSprzedazWiersz a)
        {
            LpSprzedazy = a.LpSprzedazy;
            DataSprzedazy = a.DataSprzedazy;
            DataWystawienia = a.DataWystawienia;
            DowodSprzedazy = a.DowodSprzedazy;
            NazwaKontrahenta = a.NazwaKontrahenta;
            K_10 = a.K_10;
            K_11 = a.K_11;
            K_12 = a.K_12;
            K_13 = a.K_13;
            K_14 = a.K_14;
            K_15 = a.K_15;
            K_16 = a.K_16;
            K_17 = a.K_17;
            K_18 = a.K_18;
            K_19 = a.K_19;
            K_20 = a.K_20;
            K_21 = a.K_21;
            K_22 = a.K_22;
            K_23 = a.K_23;
            K_24 = a.K_24;
            K_25 = a.K_25;
            K_26 = a.K_26;
            K_27 = a.K_27;
            K_28 = a.K_28;
            K_29 = a.K_29;
            K_30 = a.K_30;
            K_31 = a.K_31;
            K_32 = a.K_32;
            K_33 = a.K_33;
            K_34 = a.K_34;
            K_35 = a.K_35;
            K_36 = a.K_36;
            SprzedazVAT_Marza = a.SprzedazVAT_Marza;
            NrKontrahenta = a.NrKontrahenta;
            KodKrajuNadaniaTIN = a.KodKrajuNadaniaTIN;
            TypDokumentu = a.TypDokumentu;
            GTU_01 = a.GTU_01;
            GTU_02 = a.GTU_02;
            GTU_03 = a.GTU_03;
            GTU_04 = a.GTU_04;
            GTU_05 = a.GTU_05;
            GTU_06 = a.GTU_06;
            GTU_07 = a.GTU_07;
            GTU_08 = a.GTU_08;
            GTU_09 = a.GTU_09;
            GTU_10 = a.GTU_10;
            GTU_11 = a.GTU_11;
            GTU_12 = a.GTU_12;
            GTU_13 = a.GTU_13;
            SW = a.SW;
            EE = a.EE;
            TP = a.TP;
            TT_WNT = a.TT_WNT;
            TT_D = a.TT_D;
            MR_T = a.MR_T;
            MR_UZ = a.MR_UZ;
            I_42 = a.I_42;
            I_63 = a.I_63;
            B_SPV = a.B_SPV;
            B_SPV_DOSTAWA = a.B_SPV_DOSTAWA;
            B_MPV_PROWIZJA = a.B_MPV_PROWIZJA;
            MPP = a.MPP;
            KorektaPodstawyOpodt = a.KorektaPodstawyOpodt;

        }

    }
    public class JpkExt : JPK , INotifyPropertyChanged
    {

        public JpkExt()
        {
            Rej = new ObservableCollection<DbRej>();
        }
        public string  DB { get; set; }
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged( String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        public void setCel(int poz)
        {
            this.Naglowek.CelZlozenia.Value = Convert.ToSByte(this.Cel.Cel[poz].Key);
            NotifyPropertyChanged();
        }
        public void setUrzad(int poz)
        {
            string kod = this.Urz.Lista[poz].Kod;
            if(kod.Equals("0271"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item0271;
                this.UsNazwa = this.Urz.Lista[poz].Describe;
            }
            if (kod.Equals("0225"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item0225;
                this.UsNazwa = this.Urz.Lista[poz].Describe;
            }
            if (kod.Equals("1471"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item1471;
                this.UsNazwa = this.Urz.Lista[poz].Describe;
            }
            NotifyPropertyChanged();
        }
        private Decimal p39;
        public Decimal P39 {
            get 
            {
                return p39;
            }
            set
                {
                p39 = value;
                this.Deklaracja.PozycjeSzczegolowe.P_39 = P39.ToString();
                    NotifyPropertyChanged();
                }
             }
        public ObservableCollection<JPKSprzedazWierszExt> ViewSP { get; set; }
        public ObservableCollection<JPKEwidencjaZakupWiersz> ViewZA { get; set; }
        public ObservableCollection<DbRej> Rej { get; set; }
        public JPKSumyKontrola Sumy { get; set; }
        private string outscalony;
        private string outdb;
        public string outDB
        {
            get
            {
                return outdb;
            }
            set
            {
                outdb = value;
                NotifyPropertyChanged();
            }
        }

        public string cert { get; set; }
        public string outScalony 
        { 
            get
            {
                return outscalony;
            }
            set
            {
                outscalony = value;
                NotifyPropertyChanged();
            }
        }
        public string  UsNazwa { get; set; }

        private bool p55;
        public bool P55 
        {   get
            {
                return p55;
            }
            set
            {
                p55 = value;
                this.Deklaracja.PozycjeSzczegolowe.ItemElementName = ItemChoiceType.P_55;
                this.Deklaracja.PozycjeSzczegolowe.Item = 1;
                NotifyPropertyChanged();
            }
        }
        private bool p56;

        public bool P56 
        {
            get
            {
                return p56;
            }
            set
            {
                p56 = value;
                this.Deklaracja.PozycjeSzczegolowe.ItemElementName = ItemChoiceType.P_56;
                this.Deklaracja.PozycjeSzczegolowe.Item = 1;
                NotifyPropertyChanged();
            }
        }
        private bool p57;
        public bool P57 
        {
            get
            {
                return p57;
            }
            set
            {
                p57 = value;
                this.Deklaracja.PozycjeSzczegolowe.ItemElementName = ItemChoiceType.P_57;
                this.Deklaracja.PozycjeSzczegolowe.Item = 1;
                NotifyPropertyChanged();
            }
        }
        private bool p58;
        public bool P58 
        {
            get
            {
                return p58;
            } 
            set
            {
                p58 = value;
                this.Deklaracja.PozycjeSzczegolowe.ItemElementName = ItemChoiceType.P_58;
                this.Deklaracja.PozycjeSzczegolowe.Item = 1;
                NotifyPropertyChanged();
            }
        }
        private bool p59;
        public bool P59 
        {
            get
            {
                return p59;
            }
            set
            {
                p59 = value;
                if (value == true)
                {
                    this.Deklaracja.PozycjeSzczegolowe.P_59 = 1;
                }
                else
                {
              //      this.Deklaracja.PozycjeSzczegolowe.P_59 = 0;
                }
                NotifyPropertyChanged();
            }
        }
        private String p60;
        public String P60 
        {
            get
            {
                return p60;
            }
            set
            {
                p60 = value;
                this.Deklaracja.PozycjeSzczegolowe.P_60 = p60;
                NotifyPropertyChanged();
            }
        }
        private String p62;
        public String P62 
        {
            get
            {
                return p62;
            }
            set
            {
                p62 = value;
                this.Deklaracja.PozycjeSzczegolowe.P_62 = p62;
                NotifyPropertyChanged();
            }
        }
        public bool P63 { get; set; }
        public bool P64 { get; set; }
        public bool P65 { get; set; }
        public bool P66 { get; set; }
        public bool P67 { get; set; }
        public TCels Cel { get; set; }
        public US Urz { get; set; }
        public bool wczytalemGL { get; set; }
        public bool wczytalemIL { get; set; }

        private String uzKorekty;
        public String UzKorekty
        {
            get
            {
                return uzKorekty;
            }
            set
            {
                uzKorekty = value;
                if (this.Deklaracja != null)
                {
                    this.Deklaracja.PozycjeSzczegolowe.P_ORDZU = uzKorekty;
                }
                NotifyPropertyChanged();
            }
        }
        public bool bezDeklaracji { get; set; }
        public int allGtu1 { get; set; }
        public int allGtu2 { get; set; }
        public int allGtu3 { get; set; }
        public int allGtu4 { get; set; }
        public int allGtu5 { get; set; }
        public int allGtu6 { get; set; }
        public int allGtu7 { get; set; }
        public int allGtu8 { get; set; }
        public int allGtu9 { get; set; }
        public int allGtu10 { get; set; }
        public int allGtu11 { get; set; }
        public int allGtu12 { get; set; }
        public int allGtu13 { get; set; }
        public int allmpp { get; set; }
        public int alltp { get; set; }
        public int allmruz { get; set; }
        public int allBrak { get; set; }
    }
}
