﻿using System;
using System.Collections.Generic;
using System.IO;
using System.IO.Compression;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace JPK_VDEK.Core
{
    public class Wysylaj
    {
        public string AesIV256 { get; set; }
        public int length { get; set; }
        public long filezipLen { get; set; }
        public string filexml { get; set; }
        public string hashxml { get; set; }
        public string filezip { get; set; }
        public string key { get; set; }
        public byte[] datOut { get; set; }
        public byte[] sigKey { get; set; }
        public byte[] md5 { get; set; }
        public string md5Base { get; set; }
        public int PoliczHash(String fileXml)
        {
            filexml = Path.GetFileNameWithoutExtension(fileXml) + ".xml";
            string xml = File.ReadAllText(fileXml);
            length = xml.Length;
            using (SHA256 sha256Hash = SHA256.Create())
            {
                // ComputeHash - returns byte array  
                byte[] bytes = sha256Hash.ComputeHash(Encoding.UTF8.GetBytes(xml));

                // Convert byte array to a string   
                //  StringBuilder builder = new StringBuilder();
                //  for (int i = 0; i < bytes.Length; i++)
                //  {
                //      builder.Append(bytes[i].ToString("x2"));
                //  }
                //  hashxml= builder.ToString();
                hashxml = Convert.ToBase64String(bytes);
            }
            return 0;
        }
        public int Skompresuj(String fileXml)
        {
            filezip = Path.GetDirectoryName(fileXml) + "\\" + Path.GetFileNameWithoutExtension(fileXml) + ".zip";
            string patharch = Path.GetDirectoryName(fileXml) + "\\" + Path.GetFileNameWithoutExtension(fileXml);
            Directory.CreateDirectory(patharch);
            File.Copy(fileXml, patharch+"\\"+ Path.GetFileNameWithoutExtension(fileXml)+".xml", true);
            ZipFile.CreateFromDirectory(patharch, filezip);
            FileInfo info = new FileInfo(filezip);
            filezipLen = info.Length;
            return 0;
        }
        public int Zaszyfruj(string cert)
        {
            key = @"5TGB&YHN7UJM(IK<5TGB&YHN7UJM(IK<";
            datOut = Encrypt256(filezip, key);
            sigKey = SigKey(key, cert);
            
            return 0;
        }
        public int PoliczMD5()
        {
            md5 = new MD5CryptoServiceProvider().ComputeHash(datOut);
            md5Base = Convert.ToBase64String(md5);
            return 0;
        }
        public int Podpisz()
        {
            InitUploadType meta = new InitUploadType();
           
            meta.EncryptionKey.Value = Convert.ToBase64String(sigKey);
            meta.DocumentType = InitUploadTypeDocumentType.JPK;
            meta.DocumentList.Document.FormCode.systemCode = "JPK_V7M (1)";
            meta.DocumentList.Document.FormCode.schemaVersion = "1-2E";
            meta.DocumentList.Document.FormCode.Value = "JPK_VAT";
            meta.DocumentList.Document.FileName = filexml;
            meta.DocumentList.Document.ContentLength = length;
            meta.DocumentList.Document.HashValue.Value = hashxml;
            meta.DocumentList.Document.FileSignatureList.filesNumber = 1;
          //  ArrayOfFileSignatureTypePackagingSplitZip splitzip = new ArrayOfFileSignatureTypePackagingSplitZip();
          //  meta.DocumentList.Document.FileSignatureList.Packaging.Item = splitzip
            ArrayOfFileSignatureTypeEncryptionAES aes = new ArrayOfFileSignatureTypeEncryptionAES();
            var base64EncodedBytes = System.Convert.FromBase64String(AesIV256);
            aes.IV.Value = System.Convert.ToBase64String(base64EncodedBytes);
            
            meta.DocumentList.Document.FileSignatureList.Encryption.Item = aes;
            FileSignatureType sig = new FileSignatureType();
            sig.OrdinalNumber =1;
            sig.FileName = filezip;
            sig.ContentLength = Convert.ToInt32(filezipLen);
            sig.HashValue.Value = md5Base;
            meta.DocumentList.Document.FileSignatureList.FileSignature.Add(sig);

            String xmlmeta = meta.Serialize();
            return 0;
        }
        public int WyslijPlik()
        {
            return 0;
        }
        public int Sprawdz()
        {
            return 0;
        }
        public int GenerujUPO()
        {
            return 0;
        }

        private byte[] Encrypt256(string file, string key)
        {
            AesCryptoServiceProvider aes = new AesCryptoServiceProvider();
            AesIV256 = @"!QAZ2WSX#EDC4RFV";
            aes.BlockSize = 128;
            aes.KeySize = 128;
            aes.Mode = CipherMode.CBC;
            aes.Padding = PaddingMode.PKCS7;
            aes.IV = Encoding.UTF8.GetBytes(AesIV256);
            aes.Key = Encoding.UTF8.GetBytes(key);
            BinaryReader reader = new BinaryReader(File.Open(file, FileMode.Open));
            byte[] src = reader.ReadBytes((int)reader.BaseStream.Length);
            using (ICryptoTransform encrypt = aes.CreateEncryptor())
            {
                byte[] dest = encrypt.TransformFinalBlock(src, 0, src.Length);
                return dest;
            }
        }
        private byte[] SigKey(string key, string publicKey)
        {
            UnicodeEncoding _encoder = new UnicodeEncoding();
            byte[] encryptData;
            RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
            byte[] Exponent = { 1, 0, 1 };
            RSAParameters rsaParam = rsa.ExportParameters(false);
            rsaParam.Modulus = Convert.FromBase64String(File.ReadAllText(publicKey).Replace("-----BEGIN CERTIFICATE-----", "").Replace("-----END CERTIFICATE-----", ""));
            rsaParam.Exponent = Exponent;
            rsa.ImportParameters(rsaParam);
            var dataToEncrypt = _encoder.GetBytes(key);
            encryptData = rsa.Encrypt(dataToEncrypt, false);
            return encryptData;
        }
    }
}
